=== src/colmap/math/CMakeLists.txt ===
# Copyright (c) 2023, ETH Zurich and UNC Chapel Hill.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#
#     * Neither the name of ETH Zurich and UNC Chapel Hill nor the names of
#       its contributors may be used to endorse or promote products derived
#       from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.


set(FOLDER_NAME "math")

COLMAP_ADD_LIBRARY(
    NAME colmap_math
    SRCS
        graph_cut.h graph_cut.cc
        math.h math.cc
        matrix.h
        polynomial.h polynomial.cc
        random.h random.cc
    PUBLIC_LINK_LIBS
        colmap_util
        Boost::graph
        Eigen3::Eigen
    PRIVATE_LINK_LIBS
        metis
)

COLMAP_ADD_TEST(
    NAME graph_cut_test
    SRCS graph_cut_test.cc
    LINK_LIBS colmap_math
)
COLMAP_ADD_TEST(
    NAME math_test
    SRCS math_test.cc
    LINK_LIBS colmap_math
)
COLMAP_ADD_TEST(
    NAME matrix_test
    SRCS matrix_test.cc
    LINK_LIBS colmap_math
)
COLMAP_ADD_TEST(
    NAME polynomial_test
    SRCS polynomial_test.cc
    LINK_LIBS colmap_math
)
COLMAP_ADD_TEST(
    NAME random_test
    SRCS random_test.cc
    LINK_LIBS colmap_math
)
