=== debian/changelog ===
colmap (3.8+git20231101+ds-2build1) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 15:47:36 +0100

colmap (3.8+git20231101+ds-2) unstable; urgency=medium

  * d/control: add missing b-d libcgal-dev. (Closes: #1055256)

 -- Gürkan Myczko <tar@debian.org>  Fri, 03 Nov 2023 11:30:29 +0100

colmap (3.8+git20231101+ds-1) unstable; urgency=medium

  * New upstream version. (Closes: #1054556)
  * Bump standards version to 4.6.2.
  * d/colmap.install: updated.
  * d/clean: updated.
  * d/copyright: updated.

 -- Gürkan Myczko <tar@debian.org>  Wed, 01 Nov 2023 17:19:40 +0100
