=== debian/control ===
Source: colmap
Section: science
Priority: optional
Maintainer: Gürkan Myczko <tar@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 libeigen3-dev,
 libgoogle-glog-dev,
 libceres-dev,
 libcgal-dev,
 libqt5opengl5-desktop-dev,
 libflann-dev,
 libfreeimage-dev,
 libglew-dev,
 libmetis-dev,
 libsqlite3-dev,
 libboost-system-dev,
 libboost-program-options-dev,
 libboost-filesystem-dev,
 libboost-regex-dev,
 libboost-test-dev,
 libboost-graph-dev
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/tar/colmap.git
Vcs-Browser: https://salsa.debian.org/tar/colmap
Rules-Requires-Root: no
Homepage: https://github.com/colmap/colmap

Package: colmap
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Structure-from-Motion and Multi-View Stereo
 This is a general-purpose Structure-from-Motion (SfM) and Multi-View
 Stereo (MVS) pipeline with a graphical and command-line interface. It
 offers a wide range of features for reconstruction of ordered and
 unordered image collections.
